﻿Imports C1.Win.C1FlexGrid

Public Class Form1
    Dim dt1 As New DataTable("dt1")
    Dim dt2 As DataTable

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        C1FlexGrid1.AllowMerging = AllowMergingEnum.Custom

        'Bind data
        BindGrid()

        'applying merge after binding
        ApplyMerge()
    End Sub

    Private Sub ApplyMerge()
        'Clear the merged range every time before creating the merge
        C1FlexGrid1.MergedRanges.Clear()

        'Create the Merged Range
        Dim range As CellRange
        Dim temp As DataTable = CType(C1FlexGrid1.DataSource, DataTable)
        Select Case temp.TableName
            Case "dt1"
                range = C1FlexGrid1.GetCellRange(1, 1, 1, 2)
                C1FlexGrid1.MergedRanges.Add(range)
                range = C1FlexGrid1.GetCellRange(2, 1, 2, 2)
                C1FlexGrid1.MergedRanges.Add(range)
            Case "dt2"
                range = C1FlexGrid1.GetCellRange(3, 1, 3, 3)
                C1FlexGrid1.MergedRanges.Add(range)
        End Select

    End Sub

    Private Sub BindGrid()
        dt1.Columns.Add("Column 1")
        dt1.Columns.Add("Column 2")
        dt1.Rows.Add(1, 1)
        dt1.Rows.Add(2, 2)
        dt1.Rows.Add(3, 3)
        C1FlexGrid1.DataSource = dt1
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        dt2 = New DataTable("dt2")
        'Bind new data
        dt2.Columns.Add("Column 1")
        dt2.Columns.Add("Column 2")
        dt2.Columns.Add("Column 3")
        dt2.Rows.Add(1, 1, 1)
        dt2.Rows.Add(2, 2, 2)
        dt2.Rows.Add(3, 3, 3)
        C1FlexGrid1.DataSource = dt2

        'appling merge for new data
        ApplyMerge()
    End Sub
End Class
